/* Problem URL: https://codeforces.com/problemset/problem/706/D */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

struct node {
    int nodes[2];
    int count[2];

    node(): count(0) {
        fill(nodes, nodes + 2, 0);
    }

    int& operator[](int i) {
        return nodes[i];
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    V<node> bits(1);

    while (n--) {
        char op;
        ll num;
        cin >> op >> num;

        auto add = [&](ll num){
            int now = 0;
            for (int i = 31; i >= 0; i--) {
                int bit = (num >> i) & 1;
                if (bits[now][bit] == 0) {
                    bits[now][bit] = bits.size();
                    bits.emplace_back();
                }

                bits[now].count[bit]++;
                now = bits[now][bit];
            }
        };

        auto rem = [&](ll num) {
            int now = 0;
            for (int i = 31; i >= 0; i--) {
                int bit = (num >> i) & 1;
                bits[now].count[bit]--;
                if (bits[now].count[bit] == 0) {
                    bits[now][bit] = 0;
                    break;
                }
                now = bits[now][bit];
            }
        };

        function<ll(ll, int, int)> search = [&](ll num, int i, int count){
            if (count < 0) {
                return num;
            }

            ll bit = (num >> count) & 1;
            if (bits[i][!bit] == 0) {
                if (bits[i][bit] == 0) {
                    return num;
                }
                return search(num ^ (bit << count), bits[i][bit], count - 1);
            }

            ll ans = search(num ^ (!bit << count), bits[i][!bit], count - 1);
            if (ans > num || bits[i][bit] == 0) {
                return ans;
            }

            ll tmp = search(num ^ (bit << count), bits[i][bit], count - 1);

            return max(ans, tmp);
        };

        if (op == '+') {
            add(num);
        } else if (op == '-') {
            rem(num);
        } else {
            cout << max(search(num, 0, 31), num) << '\n';
        }
    }
}
